#include<stdlib.h>
#include<stdio.h>
#include<time.h>

#include"graphes.h"
#include"graphesAleatoires.h"

int genererGraphe(graphe *g,
                  unsigned int nbSommets, unsigned int nbArcs, int connexe) {
  if (nbSommets == 0 && nbArcs > 0)
    return -1;
  
  if (nbArcs > nbSommets * (nbSommets - 1))
    return - 1;
    
  if (connexe != 0 && nbArcs  < 2 * (nbSommets - 1))
    return - 1;
  
  // Ajout des sommets
  for (unsigned int i = 0; i < nbSommets; i++)
    ajouterSommet(g,0);  
    
  srand(time(0));
  
  if (connexe != 0) { // Le graphe doit etre connexe
    int nbConnectes = 1;
    int nbNonConnectes = nbSommets - 1;
    int connectes[nbSommets];
    int nonConnectes[nbSommets];
    for (unsigned int i = 0; i < nbSommets - 1; i++) 
      nonConnectes[i] = i + 2;
    connectes[0] = 1;
    
    // D'abord, on fait en fait en sorte que le graphe soit connexe
    while(nbNonConnectes > 0) {
       // Un noeud parmi les connectés
      int indiceA = rand() % nbConnectes;
      int a = connectes[indiceA];  
      
      // Un noeud parmi les non-connectés
      int indiceB = rand() % nbNonConnectes;
      int b = nonConnectes[indiceB];
   
      int poids = rand() % 100 + 1;
      ajouterArc(g, a, b, poids);
      ajouterArc(g, b, a, poids);
      
      connectes[nbConnectes] = b;
      nbConnectes++;
      nonConnectes[indiceB] = nonConnectes[nbNonConnectes - 1];
      nbNonConnectes--;    
    }
  }
  
  // On complète le graphe en ajoutant des arcs aléatoires
  while ((unsigned int) (g->nbA) < nbArcs) {
    int a = rand() % (nbSommets) + 1;
    int b = rand() % (nbSommets) + 1;
    if (a != b) {
      int poids = rand() % (100) + 1; // poids des arcs entre 1 et 100
      ajouterArc(g, a, b, poids);
      ajouterArc(g, b, a, poids);
    }
  }
  return 0;             
}

